unit CBasis;

interface

Const NL = chr(13)+chr(10);

procedure MessageBox(szTitel,szText:string);

procedure ErrorBox(szTitel,szText:string);

function GetWindowsVerz(var szVerz:string):boolean;

function GetSystemVerz(var szVerz:string):boolean;

function GetProgFilesVerz:string;

procedure GetFileVersion(FileName: string; var highVersion, lowVersion:integer);

function getTempDir():string;


Function Liesc (szText, szTitel, szVorgabe:String):String;

function ReadNoYes(szTitel, szText:string):boolean;

function ReadYesNo(szTitel, szText:string):boolean;

function ReadYesNoCancel(szTitel, szText:string):word;

function AddBackSlash(szPfad:string):string;

function Komma2Point( sStr:string):string;

function  DoubleStr2(r:Double):string;

implementation

uses Dialogs,
     windows,
     SysUtils,
     Registry,
     forms;

procedure MessageBox(szTitel,szText:string);
begin
  Application.MessageBox(PChar(szText),PChar(szTitel), MB_iconExclamation+mb_OK);
end;

procedure ErrorBox(szTitel,szText:string);
begin
  // WinTypes
  Application.MessageBox(PChar(szText),PChar(szTitel), MB_IconStop+mb_OK);
end;



function GetWindowsVerz(var szVerz:string):boolean;
var zName: array[0..300] of Char;
     szWindowsVerz:string;
begin
  if getWindowsDirectory(ZName,sizeof(ZName)-1 ) = 0 then
  begin
    (* fehler *)
    ErrorBox('Fehler','Fehler bei der Bestimmung des Windowsverzeichnisses');
    szWindowsVerz := 'C:\WINDOWS\';
    result := false;
  end
  else
  begin
    szWindowsVerz := strPas(ZName);  // SysUtils
    szWindowsVerz := AddBackSlash(szWindowsVerz);
    result := true;
  end;
  szVerz := szWindowsVerz;
end;


function GetSystemVerz(var szVerz:string):boolean;
var zName: array[0..300] of Char;
     szWindowsVerz:string;
begin
  if GetSystemDirectory(ZName,sizeof(ZName)-1 ) = 0 then
  begin
    (* fehler *)
    ErrorBox('Fehler','Fehler bei der Bestimmung des Windowssystemverzeichnisses');
    szWindowsVerz := 'C:\WINDOWS\';
    result := false;
  end
  else
  begin
    szWindowsVerz := strPas(ZName);
    szWindowsVerz := AddBackSlash(szWindowsVerz);
    result := true;
  end;
  szVerz := szWindowsVerz;
end;

function GetProgFilesVerz:string;
var regist:TRegistry;
    sKey:string;
    res :string;
begin
  sKey := 'SOFTWARE\Microsoft\Windows\CurrentVersion';
  res := 'C:\Programme';
// 'C:\Programme\'
   regist:=TRegistry.Create;
   regist.Rootkey := HKEY_LOCAL_MACHINE;
    try
      if regist.Openkey(sKey,false)
      then res := regist.ReadString('ProgramFilesDir')
      else res := 'C:\Programme';
    except
      res := 'C:\Programme';
    end;
    regist.Closekey;
    result := res;
end;

function getTempDir():string;
begin
  result := AddBackSlash(SysUtils.getenvironmentVariable( 'TEMP' ));
end;


procedure GetFileVersion(FileName: string; var highVersion, lowVersion:integer);
var  InfoSize, Wnd: DWORD;
     VerBuf: Pointer;
     FI: PVSFixedFileInfo;
     VerSize: DWORD;
begin
  highVersion := 0;
  lowVersion:=0;
    // GetFileVersionInfo modifies the filename parameter data while parsing.
    // Copy the string const into a local variable to create a writeable copy.
    InfoSize := GetFileVersionInfoSize(PChar(FileName), Wnd);
    if InfoSize <> 0 then
    begin
      GetMem(VerBuf, InfoSize);
      try
        if GetFileVersionInfo(PChar(FileName), Wnd, InfoSize, VerBuf) then
        begin
          if VerQueryValue(VerBuf, '\', Pointer(FI), VerSize) then
          begin
            HighVersion := FI.dwFileVersionMS;  // Eingetragen werden die Werte im Hexadezimalsystem
            LowVersion  := FI.dwFileVersionLS;
          end;
        end
      finally
        FreeMem(VerBuf);
      end;
    end;
end;


Function Liesc (szText, szTitel, szVorgabe:String):String;
var szZeile:string;
begin
  szZeile:=szVorgabe;
  if (InputQuery(szTitel,szText,szZeile))
  then Liesc:=szZeile
  else Liesc:='';
end;

function ReadNoYes(szTitel, szText:string):boolean;
begin
  result:=MessageDlg(szText,mtConfirmation,[mbNo,mbYes],0)=idYes;
end;

function ReadYesNo(szTitel, szText:string):boolean;
begin
  result:=MessageDlg(szText,mtConfirmation,[mbYes,mbNo],0)=idYes
end;

function ReadYesNoCancel(szTitel, szText:string):word;
begin
  result:=MessageDlg(szText,mtConfirmation,[mbYes,mbNo,mbCancel],0)
    (*  Rckgabewerte
       mrNone
       mrAbort
       mrYes
       mrOk
       mrRetry
       mrNo
       mrCancel
       mrIgnore
       mrAll
    *)
end;

function AddBackSlash(szPfad:string):string;
var n:integer;
begin
  n := Length(szPfad);
  If copy(szPfad,n,1) <> '\'
  Then result := szPfad+'\'
  else result:= szPfad;
end;


function Komma2Point( sStr:string):string;
var i:integer;
begin
  i:= pos(',',sStr);
  while i > 0 do
  begin
    sStr := copy(sStr,1,i-1) + '.' + copy(sStr,i+1,length(sStr));
    i:= pos(',',sStr);
  end;
  result := sStr;
end;


 function  DoubleStr2(r:Double):string;
  var s:string;
  begin
    s := format('%10.2f',[r]);
    s := Komma2Point(s);
    DoubleStr2:=trim(s);
  end;


end.
